# PreZ v1.0 - OpenSolaris Version
# This is the part that maps the memory and spawns a new thread

.equ    SYS_mmap, 115
.equ    SYS_lwp_create, 159

.equ    PROT_READ, 0x1
.equ    PROT_WRITE, 0x2
.equ    PROT_EXEC, 0x4

.equ    MAP_PRIVATE, 0x2
.equ    MAP_ANON, 0x100

.equ    STACK_ALIGN, 16

.equ    LWP_SUSPENDED, 0x80

.equ    ss_sp, 0x18
.equ    ss_size, 0x1c
.equ    FS, 0x28
.equ    GS, 0x24
.equ    ES, 0x2c
.equ    DS, 0x30
.equ    SS, 0x6c
.equ    CS, 0x60
.equ    UESP, 0x68
.equ    EBP, 0x3c
.equ    EIP, 0x5c

.globl _start

# Change the int3 at the parent to something like 'jmp .' to run this
# as a normal program.
_start:

# Map space
    pushl   $0
    pushl   $-1
    pushl   $(MAP_PRIVATE | MAP_ANON)
    pushl   $(PROT_READ | PROT_WRITE | PROT_EXEC)
    pushl   $8192
    pushl   $0
    pushl   $0
    movl    $SYS_mmap, %eax
    lcall   $0x7, $0x0
    addl    $28, %esp
    movl    %eax, %edi

# Copy the code
    jmp     fw
bw:
    popl    %ebx
    movl    $INJ_SIZE, %ecx
move_next:
    movb    (%ebx), %dl
    movb    %dl, (%eax)
    inc     %eax
    inc     %ebx
    loop    move_next

# Let's hope we have 512 bytes at the stack for the new ucontext!
    subl    $512, %esp
    movl    %esp, %eax
# We also need 4 bytes for the id_t
    subl    $8, %esp

# Setup new ucontext
# flags
    movl    $0xf, (%eax)
# stack
    movl    %edi, ss_sp(%eax)
    movl    $4096, ss_size(%eax)
# some registers
    movl    %fs, FS(%eax)
    movl    %gs, GS(%eax)
    movl    %es, ES(%eax)
    movl    %ds, DS(%eax)
    movl    %ss, SS(%eax)
    movl    %cs, CS(%eax)
# esp, uesp & ebp
    movl    %edi, %ebx
    addl    $(8192 - 4), %ebx
    andl    $(~(STACK_ALIGN - 1)), %ebx
    movl    %ebx, UESP(%eax)
    movl    %ebx, EBP(%eax)
    movl    %edi, EIP(%eax)

    leal    0x4(%esp), %ebx
    pushl   %ebx
    pushl   $0
    pushl   %eax
    pushl   $0
    movl    $SYS_lwp_create, %eax
    lcall   $0x7, $0x0
    addl    $532, %esp

# Return to injector
    int3

fw:
    call    bw

injected:

.include "code.s"

injected_end:

.equ    INJ_SIZE, injected_end - injected
